const Pool      = require('pg').Pool;
const LiveQuery = require('./index');

const pool = new Pool({
	"host"     : "localhost",
	"port"     : 5432,
	"user"     : "postgres",
	"database" : "test",
	"password" : "password"
});

// const create_func_sql = `
// 	CREATE OR REPLACE FUNCTION pg_temp.fnv1a(input bytea) RETURNS bigint AS $$
// 		DECLARE
// 			prime bigint DEFAULT 16777619;
// 			current bigint DEFAULT 2166136261;
// 			length int;
// 		BEGIN
// 			length := octet_length(input) - 1;

// 			FOR i IN 0..length LOOP
// 				current = current # get_byte(input, i);
// 				current = current::numeric(40, 0) * prime % 9223372036854775807;
// 			END LOOP;

// 			RETURN current;
// 		END;
// 	$$ language plpgsql
// `;

// const test_func_sql = `
// 	SELECT pg_temp.fnv1a(int8send(24534))::text AS foo
// `;

// pool.connect((error, client, done) => {
// 	client.query(create_func_sql, (error, result) => {
// 		if(error) {
// 			console.log(error);
// 		}
// 		else {
// 			client.query(test_func_sql, (error, result) => {
// 				console.log(error, result);
// 			});
// 		}
// 	});
// });

pool.connect((error, client, done) => {
		const lq = new LiveQuery(client);

		const sql = `
				SELECT
						foo.n AS fn,
						AVG(bar.n) AS bn
				FROM
					foo JOIN
					bar ON
						foo.id = bar.id
				GROUP BY
					foo.n
		`;

		const handle = lq.query(sql);

		console.time('i');

		handle.on('rows', (rows) => {
				console.timeEnd('i');
				console.log('all rows', rows);
		});

		handle.on('error', (error) => {
			console.log('error', error);
		});
});
